/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */

#ifndef IDLCOND_H
#define IDLCOND_H

#include <vector>

#include <QUB_Tree.h>
#include <qubtree_NodeFunc.h>

#include "QUB_IdlSeg.h"

QUB_Tree IdlCond( std::vector<QUB_Tree>& dataSets, QUB_Tree config, QTR_NodeFptr fillDataCB, 
				  QTR_NodeFptr reportCB, QTR_NodeFptr pctCB );

extern "C" MIL_API QTR_Impl * __stdcall
IdlCond_iface( QTR_Impl *cfg, QTR_Impl **data, QTR_INodeCFunc *fillDataCB, 
			  QTR_INodeCFunc *rptCB, QTR_INodeCFunc *pctCB );

extern "C" MIL_API QTR_Impl* __stdcall
MplexIdl_iface(QUB_IdlSegments** idlarr, int nseg, int* firsts, int* lasts);

extern "C" MIL_API QTR_Impl* __stdcall
MplexIdlWithCond_iface(QUB_IdlSegments* idl, QTR_Impl *condIdl, int maxPower);

#endif
